var foxlinks2 = {
   contentLoad: function(e) {
     
      // protect the user by wrapping with nsICondomService
      var unsafeWin = e.target.defaultView;
      if (unsafeWin.wrappedJSObject) unsafeWin = unsafeWin.wrappedJSObject;

      // guard against malicious websites masquerading as LUElinks
      var unsafeLoc = new XPCNativeWrapper(unsafeWin, 'location').location;
      var href = new XPCNativeWrapper(unsafeLoc, 'href').href;
      var hostname = new XPCNativeWrapper(unsafeLoc, 'hostname').hostname;
      var pathname = new XPCNativeWrapper(unsafeLoc, 'pathname').pathname;

      // TODO: add additional checks for wiki, archives, etc...
      // and individal php pages
      // TODO: Sandbox for scripts??
      if (foxlinks2.isInjectable(href) && /luelinks\.net/.test(hostname)) {
	    var script = foxlinks2.getUrlContents(
	       'chrome://foxlinks2/content/modules/nueser.js'
	    );
	    eval('(function() {'+script+'})()');
	 }
      },


      // isInjectable copied almost directly from Greasemonkey isGreasemonkeyable
      isInjectable: function(url) {
	 var scheme=Components.classes["@mozilla.org/network/io-service;1"]
	 .getService(Components.interfaces.nsIIOService)
	 .extractScheme(url);
	 return (
	    (scheme == "http" || scheme == "https") &&
	    !/hiddenWindow\.html$/.test(url)
	 );
      },

      // getUrlContents copied directly from Greasemonkey getUrlContents
      // we don't really need to know how this works, tbqh
      // it just returns the contents of a url that is passed to it
      getUrlContents: function(aUrl){
	 var ioService=Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	 var scriptableStream=Components.classes["@mozilla.org/scriptableinputstream;1"].getService(Components.interfaces.nsIScriptableInputStream);

	 var channel=ioService.newChannel(aUrl, null, null);
	 var input=channel.open();
	 scriptableStream.init(input);
	 var str=scriptableStream.read(input.available());
	 scriptableStream.close();
	 input.close();

	 return str;
      },



      onLoad: function() {
	 // grab browser object
	 var appcontent = window.document.getElementById('appcontent');
	 

	 // no point in loading twice so we check for it
	 if (appcontent) {
	    appcontent.addEventListener('DOMContentLoaded',foxlinks2.contentLoad, true);
	 }
      },

      onUnLoad: function() {
	 // remove unnecessary listeners
	 window.removeEventListener('load', foxlinks2.onLoad, false);
	 window.removeEventListener('unload', foxlinks2.onUnLoad, false);
	 window.document.getElementById('appcontent').removeEventListener('DOMContentLoaded',foxlinks2.contentLoad,false);
      }
      } // end object foxlinks2

      window.addEventListener('load', foxlinks2.onLoad, false);
      window.addEventListener('load', foxlinks2.onUnLoad, false);
